import Content from './Content';
import React from "react"
import ReactDOM from 'react-dom/client';
import SeniverseLoader from '@seniverse/loader'

//  技术问题请联系：
//   ▄▄▄▄▄▄▄  ▄    ▄    ▄ ▄▄▄  ▄▄▄▄▄▄▄
//   █ ▄▄▄ █ ▀█▄█▀▀▄█ ▀  ▄██▄  █ ▄▄▄ █
//   █ ███ █ ▀▀▄▀▄█▄▀▀▀▄▄▄  ██ █ ███ █
//   █▄▄▄▄▄█ █ █ ▄ ▄▀█▀█ ▄ █ ▄ █▄▄▄▄▄█
//   ▄▄▄▄▄ ▄▄▄▄▄ █▄ █▄▄█▄▄▀█▄▄▄ ▄ ▄ ▄ 
//  █ ▄   ▄█▄█ ▄▄ █▄ ▄ ▀▄▀█▀  █  ▄▀█▀
//  █▄ █▄ ▄▀▀█▀█ ▄  ▀▄▀ ▀▀▄█▄█ ▄▄▄▀  
//  ▄ ██ ▄▄ ▀█▀ ▀▀▀▄  ▀▀▀▀ ▀ ▀█ ▄  █▀
//  ▀█▄▀ █▄▄ █▀ █▄ ▀▄▄█▄▄▀▀▀█▄  ▄ ▀▄ 
//  ▀▀▄▄▀█▄▀██▀▄▄▄▄▄▄█ ▀▄▀▀▀▄ █▄▄█ █▀
//  █▄▄▀ ▀▄▄█▀▄█▄▄▄█▄▄  ▀▀▄█▄█ ▄█ ▀▄ 
//  █▀▀ ▀▄▄ ▀█▀ █▄▀▄ ▄ ▀▀▀ ▀▀▄█▀▄█ █▀
//  █ █▄█▄▄█ ▄▄▄▀▄█ ▀▄█ █▀▄ █▄████▀ ▄
//  ▄▄▄▄▄▄▄ █▄▀▀ ▄▀▄ ▀ ▀ █ ██ ▄ ██▀▄▀
//  █ ▄▄▄ █ ▄▄█▀ ▄▄█▄▄▄▀▀▀█▀█▄▄▄█▀▀▄▀
//  █ ███ █ █  ▀ ▄ ▄   ▀██▄▀█ ▄▀▀█ ▄ 
//  █▄▄▄▄▄█ █▄▀▄ ▄▀ ▀▄█  ▀██▄▀██▀█▀▄ 

class App extends React.Component {
  constructor(props) {
    super(props);
    this.container = undefined;
    this.root = undefined;
    this.sdk = undefined;
  }

  componentDidMount() {
    const config = {
      version: '1.0.8',
      apiKey: "YOUR OWN SENIVERSE API KEY",//SDK的key,填写自己的key
      mapConfig: {
        layers: ["wns_100m", "ghi", "tem", "pre", "rhu", "vis"],
        tileConfig: {
          accessToken:"aaa.bbb.ccc",
        },
        indicator: {
          outer: "#fff",
          inner: "#3C7EFF",
          width: 2,
          radius: 6,
        },
      },

      panel: true,

      contents: {
        markerContent: (paras) => {
          this.container = document.createElement("div")
          this.root = ReactDOM.createRoot(this.container)
          this.root.render(<Content paras={paras} />)
          return this.container
        },
        indicatorContent: (paras) => {
          this.container = document.createElement("div")
          this.root = ReactDOM.createRoot(this.container)
          this.root.render(<Content paras={paras} />)
          this.container.setAttribute(
            'style',
            'width: 300px;',
          );
          return this.container
        },
        onMarkerClose: () => {
          this.root.unmount()
          this.container = undefined;
        },
        onMarkerClick: (paras) => {
          console.log("click: ", paras);
        },
      },
    };
    new SeniverseLoader(config).load().then((inst) => {
      this.sdk = inst;
      this.sdk.mounted = () => {
        this.sdk.onClick = (longitude, latitude) => {
          console.log("经度:", longitude, " 纬度:", latitude);
        };
        this.sdk.addMarker({
          latitude: 39.36827,
          longitude: 109.37988,
          id: 'id-1',
          label: "I am label",
          labelClass: "custom-label-class",
          labelDirection: "left",//right, left, top, bottom, center, auto
          extra: {
            id: 'extra-1',
            content: 'content',
          }
        })
      };

      this.sdk.mount("#map-container");
    })

  }

  componentWillUnmount() {
    this.root && this.root.unmount()
    this.container = undefined;
    this.sdk.unmount()
  }

  render() {
    return (
      <div class="main-content">
        <div id="map-container"></div>
      </div>
    );
  }

}

export default App;
